
> module Bits (Bits(..), shiftL, shiftR) where

> import Word
> import qualified Bit

> class Bits a where
>  (.&.), (.|.), xor :: a -> a -> a
>  complement        :: a -> a
>  shift             :: a -> Int -> a
>  -- rotate            :: a -> Int -> a
>  -- bit               :: Int -> a
>  -- setBit            :: a -> Int -> a
>  -- clearBit          :: a -> Int -> a
>  -- complementBit     :: a -> Int -> a
>  -- testBit           :: a -> Int -> Bool
>  -- bitSize           :: a -> Int
>  -- isSigned          :: a -> Bool

> instance Bits Int where
>  (.&.) = (Bit.^&)
>  (.|.) = (Bit.^|)
>  xor = (Bit.xor)
>  shift a i = if i > 0 then (Bit.^<<) a i else (Bit.^>>) a (-i)
>  complement = (Bit.compl)

> shiftL a i = shift a i
> shiftR a i = shift a (-i)

